'' =================================================================================================
''
''   File....... jm_lcd_ui_demo.spin
''   Purpose.... Unified object for LCD UI project (Nuts & Volts, September 2009)
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2009 Jon McPhalen
''   E-mail..... jon@jonmcphalen.com
''   Started.... 19 JUL 2009 
''   Updated.... 19 JUL 2009
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  

obj

  ui : "jm_lcd_ui"


var


pub main | b
                                                                
  ui.init                                                       ' initialize LCD UI  
  ui.blctimer(10_000)                                           ' enable backlight
  ui.scrollstr(1, 1, 8, 250, @nuts)                             ' scroll line 1, r-to-l
  ui.rscrollstr(1, 2, 8, 250, @volts)                           ' scroll line 2, l-to-r  
  repeat while ina[8]                                           ' hold while backlight on  
  ui.cls                                                        ' clear the LCD

  repeat
    b := ui.getbtns                                             ' check buttons
    if b                                                        ' any pressed?
      ui.blctimer(5_000)                                        ' yes, restart backlight timer
      case b
        %0_00001..%0_10000 : ui.green                           ' joystick only?
        %1_00000           : ui.red                             ' Esc only?
        %1_00001..%1_10000 : ui.yellow                          ' combination?
    else
      ui.ledoff                                                 ' LED off if no buttons

    ui.moveto(1, 1)                                             ' display Esc button status
    if (b & ui#BTN_ESC)
      ui.str(string("ESC"))
    else
      ui.str(string("   "))

    ui.moveto(1, 2)                                             ' display joystick status
    case (b & %011111)                                          ' mask off Esc button
      ui#BTN_UP : ui.str(string("UP"))
      ui#BTN_DN : ui.str(string("DN"))
      ui#BTN_LF : ui.str(string("LF"))
      ui#BTN_RT : ui.str(string("RT"))
      ui#BTN_OK : ui.str(string("OK"))
      other     : ui.str(string("  "))

    waitcnt(clkfreq / 25 + cnt) 


dat

nuts            byte    "        NUTS    ", 0
volts           byte    "   VOLTS        ", 0

          